#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSPViolationReportBody = 858,
  CSS = 881,
  CSS2Properties = 885,
  CSSAnimation = 900,
  CSSConditionRule = 913,
  CSSContainerRule = 930,
  CSSCounterStyleRule = 947,
  CSSCustomPropertyRegisteredEvent = 967,
  CSSFontFaceRule = 1000,
  CSSFontFeatureValuesRule = 1016,
  CSSFontPaletteValuesRule = 1041,
  CSSGroupingRule = 1066,
  CSSImportRule = 1082,
  CSSKeyframeRule = 1096,
  CSSKeyframesRule = 1112,
  CSSLayerBlockRule = 1129,
  CSSLayerStatementRule = 1147,
  CSSMarginRule = 1169,
  CSSMediaRule = 1183,
  CSSMozDocumentRule = 1196,
  CSSNamespaceRule = 1215,
  CSSNestedDeclarations = 1232,
  CSSPageDescriptors = 1254,
  CSSPageRule = 1273,
  CSSPositionTryDescriptors = 1285,
  CSSPositionTryRule = 1311,
  CSSPropertyRule = 1330,
  CSSPseudoElement = 1346,
  CSSRule = 1363,
  CSSRuleList = 1371,
  CSSScopeRule = 1383,
  CSSStartingStyleRule = 1396,
  CSSStyleDeclaration = 1417,
  CSSStyleRule = 1437,
  CSSStyleSheet = 1450,
  CSSSupportsRule = 1464,
  CSSTransition = 1480,
  Cache = 1494,
  CacheStorage = 1500,
  CallbackDebuggerNotification = 1513,
  CanonicalBrowsingContext = 1542,
  CanvasCaptureMediaStream = 1567,
  CanvasGradient = 1592,
  CanvasPattern = 1607,
  CanvasRenderingContext2D = 1621,
  CaretPosition = 1646,
  CaretStateChangedEvent = 1660,
  ChannelMergerNode = 1683,
  ChannelSplitterNode = 1701,
  ChannelWrapper = 1721,
  CharacterData = 1736,
  CheckerboardReportService = 1750,
  ChildProcessMessageManager = 1776,
  ChildSHistory = 1803,
  ChromeMessageBroadcaster = 1817,
  ChromeMessageSender = 1842,
  ChromeNodeList = 1862,
  ChromeUtils = 1877,
  ChromeWorker = 1889,
  Client = 1902,
  Clients = 1909,
  Clipboard = 1917,
  ClipboardEvent = 1927,
  ClipboardItem = 1942,
  ClonedErrorHolder = 1956,
  CloseEvent = 1974,
  CloseWatcher = 1985,
  CommandEvent = 1998,
  Comment = 2011,
  CompositionEvent = 2019,
  CompressionStream = 2036,
  ConsoleInstance = 2054,
  ConstantSourceNode = 2070,
  ContentFrameMessageManager = 2089,
  ContentProcessMessageManager = 2116,
  ContentVisibilityAutoStateChangeEvent = 2145,
  ConvolverNode = 2183,
  CookieChangeEvent = 2197,
  CookieStore = 2215,
  CountQueuingStrategy = 2227,
  CreateOfferRequest = 2248,
  Credential = 2267,
  CredentialsContainer = 2278,
  Crypto = 2299,
  CryptoKey = 2306,
  CustomElementRegistry = 2316,
  CustomEvent = 2338,
  CustomStateSet = 2350,
  DOMException = 2365,
  DOMImplementation = 2378,
  DOMLocalization = 2396,
  DOMMatrix = 2412,
  DOMMatrixReadOnly = 2422,
  DOMParser = 2440,
  DOMPoint = 2450,
  DOMPointReadOnly = 2459,
  DOMQuad = 2476,
  DOMRect = 2484,
  DOMRectList = 2492,
  DOMRectReadOnly = 2504,
  DOMStringList = 2520,
  DOMStringMap = 2534,
  DOMTokenList = 2547,
  DataTransfer = 2560,
  DataTransferItem = 2573,
  DataTransferItemList = 2590,
  DebuggerNotification = 2611,
  DebuggerNotificationObserver = 2632,
  DecompressionStream = 2661,
  DedicatedWorkerGlobalScope = 2681,
  DelayNode = 2708,
  DeprecationReportBody = 2718,
  DeviceAcceleration = 2740,
  DeviceLightEvent = 2759,
  DeviceMotionEvent = 2776,
  DeviceOrientationEvent = 2794,
  DeviceRotationRate = 2817,
  Directory = 2836,
  Document = 2846,
  DocumentFragment = 2855,
  DocumentL10n = 2872,
  DocumentTimeline = 2885,
  DocumentType = 2902,
  DominatorTree = 2915,
  DragEvent = 2929,
  DynamicsCompressorNode = 2939,
  EXT_blend_minmax = 2962,
  EXT_color_buffer_float = 2979,
  EXT_color_buffer_half_float = 3002,
  EXT_depth_clamp = 3030,
  EXT_disjoint_timer_query = 3046,
  EXT_float_blend = 3071,
  EXT_frag_depth = 3087,
  EXT_sRGB = 3102,
  EXT_shader_texture_lod = 3111,
  EXT_texture_compression_bptc = 3134,
  EXT_texture_compression_rgtc = 3163,
  EXT_texture_filter_anisotropic = 3192,
  EXT_texture_norm16 = 3223,
  Element = 3242,
  ElementInternals = 3250,
  EncodedAudioChunk = 3267,
  EncodedVideoChunk = 3285,
  ErrorEvent = 3303,
  Event = 3314,
  EventCallbackDebuggerNotification = 3320,
  EventCounts = 3354,
  EventSource = 3366,
  EventTarget = 3378,
  Exception = 3390,
  ExtendableEvent = 3400,
  ExtendableMessageEvent = 3416,
  ExtensionAlarms = 3439,
  ExtensionBrowser = 3455,
  ExtensionBrowserSettings = 3472,
  ExtensionBrowserSettingsColorManagement = 3497,
  ExtensionDns = 3537,
  ExtensionEventManager = 3550,
  ExtensionMockAPI = 3572,
  ExtensionPort = 3589,
  ExtensionProxy = 3603,
  ExtensionRuntime = 3618,
  ExtensionScripting = 3635,
  ExtensionSetting = 3654,
  ExtensionTest = 3671,
  External = 3685,
  FeaturePolicy = 3694,
  FeaturePolicyViolationReportBody = 3708,
  FetchEvent = 3741,
  FetchObserver = 3752,
  File = 3766,
  FileList = 3771,
  FileReader = 3780,
  FileReaderSync = 3791,
  FileSystem = 3806,
  FileSystemDirectoryEntry = 3817,
  FileSystemDirectoryHandle = 3842,
  FileSystemDirectoryHandle_AsyncIterator = 3868,
  FileSystemDirectoryIterator = 3908,
  FileSystemDirectoryReader = 3936,
  FileSystemEntry = 3962,
  FileSystemFileEntry = 3978,
  FileSystemFileHandle = 3998,
  FileSystemHandle = 4019,
  FileSystemSyncAccessHandle = 4036,
  FileSystemWritableFileStream = 4063,
  Flex = 4092,
  FlexItemValues = 4097,
  FlexLineValues = 4112,
  FluentBundle = 4127,
  FluentBundleAsyncIterator = 4140,
  FluentBundleIterator = 4166,
  FluentPattern = 4187,
  FluentResource = 4201,
  FocusEvent = 4216,
  FontFace = 4227,
  FontFaceSet = 4236,
  FontFaceSetIterator = 4248,
  FontFaceSetLoadEvent = 4268,
  FormData = 4289,
  FormData_Iterator = 4298,
  FormDataEvent = 4316,
  FragmentDirective = 4330,
  FrameCrashedEvent = 4348,
  FrameLoader = 4366,
  GPU = 4378,
  GPUAdapter = 4382,
  GPUAdapterInfo = 4393,
  GPUBindGroup = 4408,
  GPUBindGroupLayout = 4421,
  GPUBuffer = 4440,
  GPUBufferUsage = 4450,
  GPUCanvasContext = 4465,
  GPUColorWrite = 4482,
  GPUCommandBuffer = 4496,
  GPUCommandEncoder = 4513,
  GPUCompilationInfo = 4531,
  GPUCompilationMessage = 4550,
  GPUComputePassEncoder = 4572,
  GPUComputePipeline = 4594,
  GPUDevice = 4613,
  GPUDeviceLostInfo = 4623,
  GPUError = 4641,
  GPUInternalError = 4650,
  GPUMapMode = 4667,
  GPUOutOfMemoryError = 4678,
  GPUPipelineLayout = 4698,
  GPUQuerySet = 4716,
  GPUQueue = 4728,
  GPURenderBundle = 4737,
  GPURenderBundleEncoder = 4753,
  GPURenderPassEncoder = 4776,
  GPURenderPipeline = 4797,
  GPUSampler = 4815,
  GPUShaderModule = 4826,
  GPUShaderStage = 4842,
  GPUSupportedFeatures = 4857,
  GPUSupportedLimits = 4878,
  GPUTexture = 4897,
  GPUTextureUsage = 4908,
  GPUTextureView = 4924,
  GPUUncapturedErrorEvent = 4939,
  GPUValidationError = 4963,
  GainNode = 4982,
  Gamepad = 4991,
  GamepadAxisMoveEvent = 4999,
  GamepadButton = 5020,
  GamepadButtonEvent = 5034,
  GamepadEvent = 5053,
  GamepadHapticActuator = 5066,
  GamepadLightIndicator = 5088,
  GamepadPose = 5110,
  GamepadServiceTest = 5122,
  GamepadTouch = 5141,
  Geolocation = 5154,
  GeolocationCoordinates = 5166,
  GeolocationPosition = 5189,
  GeolocationPositionError = 5209,
  GetUserMediaRequest = 5234,
  GleanBoolean = 5254,
  GleanCategory = 5267,
  GleanCounter = 5281,
  GleanCustomDistribution = 5294,
  GleanDatetime = 5318,
  GleanDenominator = 5332,
  GleanEvent = 5349,
  GleanImpl = 5360,
  GleanLabeled = 5370,
  GleanMemoryDistribution = 5383,
  GleanMetric = 5407,
  GleanNumerator = 5419,
  GleanObject = 5434,
  GleanPingsImpl = 5446,
  GleanQuantity = 5461,
  GleanRate = 5475,
  GleanString = 5485,
  GleanStringList = 5497,
  GleanText = 5513,
  GleanTimespan = 5523,
  GleanTimingDistribution = 5537,
  GleanUrl = 5561,
  GleanUuid = 5570,
  Grid = 5580,
  GridArea = 5585,
  GridDimension = 5594,
  GridLine = 5608,
  GridLines = 5617,
  GridTrack = 5627,
  GridTracks = 5637,
  HTMLAllCollection = 5648,
  HTMLAnchorElement = 5666,
  HTMLAreaElement = 5684,
  HTMLAudioElement = 5700,
  HTMLBRElement = 5717,
  HTMLBaseElement = 5731,
  HTMLBodyElement = 5747,
  HTMLButtonElement = 5763,
  HTMLCanvasElement = 5781,
  HTMLCollection = 5799,
  HTMLDListElement = 5814,
  HTMLDataElement = 5831,
  HTMLDataListElement = 5847,
  HTMLDetailsElement = 5867,
  HTMLDialogElement = 5886,
  HTMLDirectoryElement = 5904,
  HTMLDivElement = 5925,
  HTMLDocument = 5940,
  HTMLElement = 5953,
  HTMLEmbedElement = 5965,
  HTMLFieldSetElement = 5982,
  HTMLFontElement = 6002,
  HTMLFormControlsCollection = 6018,
  HTMLFormElement = 6045,
  HTMLFrameElement = 6061,
  HTMLFrameSetElement = 6078,
  HTMLHRElement = 6098,
  HTMLHeadElement = 6112,
  HTMLHeadingElement = 6128,
  HTMLHtmlElement = 6147,
  HTMLIFrameElement = 6163,
  HTMLImageElement = 6181,
  HTMLInputElement = 6198,
  HTMLLIElement = 6215,
  HTMLLabelElement = 6229,
  HTMLLegendElement = 6246,
  HTMLLinkElement = 6264,
  HTMLMapElement = 6280,
  HTMLMarqueeElement = 6295,
  HTMLMediaElement = 6314,
  HTMLMenuElement = 6331,
  HTMLMetaElement = 6347,
  HTMLMeterElement = 6363,
  HTMLModElement = 6380,
  HTMLOListElement = 6395,
  HTMLObjectElement = 6412,
  HTMLOptGroupElement = 6430,
  HTMLOptionElement = 6450,
  HTMLOptionsCollection = 6468,
  HTMLOutputElement = 6490,
  HTMLParagraphElement = 6508,
  HTMLParamElement = 6529,
  HTMLPictureElement = 6546,
  HTMLPreElement = 6565,
  HTMLProgressElement = 6580,
  HTMLQuoteElement = 6600,
  HTMLScriptElement = 6617,
  HTMLSelectElement = 6635,
  HTMLSlotElement = 6653,
  HTMLSourceElement = 6669,
  HTMLSpanElement = 6687,
  HTMLStyleElement = 6703,
  HTMLTableCaptionElement = 6720,
  HTMLTableCellElement = 6744,
  HTMLTableColElement = 6765,
  HTMLTableElement = 6785,
  HTMLTableRowElement = 6802,
  HTMLTableSectionElement = 6822,
  HTMLTemplateElement = 6846,
  HTMLTextAreaElement = 6866,
  HTMLTimeElement = 6886,
  HTMLTitleElement = 6902,
  HTMLTrackElement = 6919,
  HTMLUListElement = 6936,
  HTMLUnknownElement = 6953,
  HTMLVideoElement = 6972,
  HashChangeEvent = 6989,
  Headers = 7005,
  Headers_Iterator = 7013,
  HeapSnapshot = 7030,
  Highlight = 7043,
  HighlightRegistry = 7053,
  History = 7071,
  IDBCursor = 7079,
  IDBCursorWithValue = 7089,
  IDBDatabase = 7108,
  IDBFactory = 7120,
  IDBIndex = 7131,
  IDBKeyRange = 7140,
  IDBObjectStore = 7152,
  IDBOpenDBRequest = 7167,
  IDBRequest = 7184,
  IDBTransaction = 7195,
  IDBVersionChangeEvent = 7210,
  IIRFilterNode = 7232,
  IOUtils = 7246,
  IdentityCredential = 7254,
  IdleDeadline = 7273,
  Image = 7286,
  ImageBitmap = 7292,
  ImageBitmapRenderingContext = 7304,
  ImageCapture = 7332,
  ImageCaptureError = 7345,
  ImageCaptureErrorEvent = 7363,
  ImageData = 7386,
  ImageDecoder = 7396,
  ImageDocument = 7409,
  ImageTrack = 7423,
  ImageTrackList = 7434,
  InputEvent = 7449,
  InspectorCSSParser = 7460,
  InspectorFontFace = 7479,
  InspectorUtils = 7497,
  InstallTriggerImpl = 7512,
  IntersectionObserver = 7531,
  IntersectionObserverEntry = 7552,
  IntlUtils = 7578,
  InvokeEvent = 7588,
  JSProcessActorChild = 7600,
  JSProcessActorParent = 7620,
  JSWindowActorChild = 7641,
  JSWindowActorParent = 7660,
  KeyEvent = 7680,
  KeyboardEvent = 7689,
  KeyframeEffect = 7703,
  L10nFileSource = 7718,
  L10nOverlays = 7733,
  L10nRegistry = 7746,
  LargestContentfulPaint = 7759,
  LegacyMozTCPSocket = 7782,
  Localization = 7801,
  Location = 7814,
  Lock = 7823,
  LockManager = 7828,
  MIDIAccess = 7840,
  MIDIConnectionEvent = 7851,
  MIDIInput = 7871,
  MIDIInputMap = 7881,
  MIDIMessageEvent = 7894,
  MIDIOutput = 7911,
  MIDIOutputMap = 7922,
  MIDIPort = 7936,
  MLS = 7945,
  MLSGroupView = 7949,
  MOZ_debug = 7962,
  MatchGlob = 7972,
  MatchPattern = 7982,
  MatchPatternSet = 7995,
  MathMLElement = 8011,
  MediaCapabilities = 8025,
  MediaControlService = 8043,
  MediaController = 8063,
  MediaDeviceInfo = 8079,
  MediaDevices = 8095,
  MediaElementAudioSourceNode = 8108,
  MediaEncryptedEvent = 8136,
  MediaError = 8156,
  MediaKeyError = 8167,
  MediaKeyMessageEvent = 8181,
  MediaKeySession = 8202,
  MediaKeyStatusMap = 8218,
  MediaKeyStatusMap_Iterator = 8236,
  MediaKeySystemAccess = 8263,
  MediaKeys = 8284,
  MediaList = 8294,
  MediaMetadata = 8304,
  MediaQueryList = 8318,
  MediaQueryListEvent = 8333,
  MediaRecorder = 8353,
  MediaRecorderErrorEvent = 8367,
  MediaSession = 8391,
  MediaSource = 8404,
  MediaStream = 8416,
  MediaStreamAudioDestinationNode = 8428,
  MediaStreamAudioSourceNode = 8460,
  MediaStreamError = 8487,
  MediaStreamEvent = 8504,
  MediaStreamTrack = 8521,
  MediaStreamTrackAudioSourceNode = 8538,
  MediaStreamTrackEvent = 8570,
  MerchantValidationEvent = 8592,
  MessageBroadcaster = 8616,
  MessageChannel = 8635,
  MessageEvent = 8650,
  MessageListenerManager = 8663,
  MessagePort = 8686,
  MessageSender = 8698,
  MimeType = 8712,
  MimeTypeArray = 8721,
  MouseEvent = 8735,
  MouseScrollEvent = 8746,
  MozCanvasPrintState = 8763,
  MozDocumentMatcher = 8783,
  MozDocumentObserver = 8802,
  MozQueryInterface = 8822,
  MozSharedMap = 8840,
  MozSharedMap_Iterator = 8853,
  MozSharedMapChangeEvent = 8875,
  MozStorageAsyncStatementParams = 8899,
  MozStorageStatementParams = 8930,
  MozStorageStatementRow = 8956,
  MozWritableSharedMap = 8979,
  MutationEvent = 9000,
  MutationObserver = 9014,
  MutationRecord = 9031,
  NamedNodeMap = 9046,
  NavigateEvent = 9059,
  Navigation = 9073,
  NavigationActivation = 9084,
  NavigationCurrentEntryChangeEvent = 9105,
  NavigationDestination = 9139,
  NavigationHistoryEntry = 9161,
  NavigationPreloadManager = 9184,
  NavigationTransition = 9209,
  Navigator = 9230,
  NetworkInformation = 9240,
  Node = 9259,
  NodeFilter = 9264,
  NodeIterator = 9275,
  NodeList = 9288,
  Notification = 9297,
  NotificationEvent = 9310,
  NotifyPaintEvent = 9328,
  OES_draw_buffers_indexed = 9345,
  OES_element_index_uint = 9370,
  OES_fbo_render_mipmap = 9393,
  OES_standard_derivatives = 9415,
  OES_texture_float = 9440,
  OES_texture_float_linear = 9458,
  OES_texture_half_float = 9483,
  OES_texture_half_float_linear = 9506,
  OES_vertex_array_object = 9536,
  OVR_multiview2 = 9560,
  OfflineAudioCompletionEvent = 9575,
  OfflineAudioContext = 9603,
  OffscreenCanvas = 9623,
  OffscreenCanvasRenderingContext2D = 9639,
  OnlyForUseInConstructor = 9673,
  Option = 9697,
  OscillatorNode = 9704,
  PageTransitionEvent = 9719,
  PaintRequest = 9739,
  PaintRequestList = 9752,
  PaintWorkletGlobalScope = 9769,
  PannerNode = 9793,
  ParentProcessMessageManager = 9804,
  Path2D = 9832,
  PathUtils = 9839,
  PaymentAddress = 9849,
  PaymentMethodChangeEvent = 9864,
  PaymentRequest = 9889,
  PaymentRequestUpdateEvent = 9904,
  PaymentResponse = 9930,
  PeerConnectionImpl = 9946,
  PeerConnectionObserver = 9965,
  Performance = 9988,
  PerformanceEntry = 10000,
  PerformanceEntryEvent = 10017,
  PerformanceEventTiming = 10039,
  PerformanceMark = 10062,
  PerformanceMeasure = 10078,
  PerformanceNavigation = 10097,
  PerformanceNavigationTiming = 10119,
  PerformanceObserver = 10147,
  PerformanceObserverEntryList = 10167,
  PerformancePaintTiming = 10196,
  PerformanceResourceTiming = 10219,
  PerformanceServerTiming = 10245,
  PerformanceTiming = 10269,
  PeriodicWave = 10287,
  PermissionStatus = 10300,
  Permissions = 10317,
  PlacesBookmark = 10329,
  PlacesBookmarkAddition = 10344,
  PlacesBookmarkChanged = 10367,
  PlacesBookmarkGuid = 10389,
  PlacesBookmarkKeyword = 10408,
  PlacesBookmarkMoved = 10430,
  PlacesBookmarkRemoved = 10450,
  PlacesBookmarkTags = 10472,
  PlacesBookmarkTime = 10491,
  PlacesBookmarkTitle = 10510,
  PlacesBookmarkUrl = 10530,
  PlacesEvent = 10548,
  PlacesEventCounts = 10560,
  PlacesFavicon = 10578,
  PlacesHistoryCleared = 10592,
  PlacesObservers = 10613,
  PlacesPurgeCaches = 10629,
  PlacesRanking = 10647,
  PlacesVisit = 10661,
  PlacesVisitRemoved = 10673,
  PlacesVisitTitle = 10692,
  PlacesWeakCallbackWrapper = 10709,
  Plugin = 10735,
  PluginArray = 10742,
  PluginCrashedEvent = 10754,
  PointerEvent = 10773,
  PopStateEvent = 10786,
  PopupBlockedEvent = 10800,
  PopupPositionedEvent = 10818,
  PositionStateEvent = 10839,
  PrecompiledScript = 10858,
  PrivateAttribution = 10876,
  ProcessMessageManager = 10895,
  ProcessingInstruction = 10917,
  ProgressEvent = 10939,
  PromiseDebugging = 10953,
  PromiseNativeHandler = 10970,
  PromiseRejectionEvent = 10991,
  PublicKeyCredential = 11013,
  PushEvent = 11033,
  PushManager = 11043,
  PushManagerImpl = 11055,
  PushMessageData = 11071,
  PushSubscription = 11087,
  PushSubscriptionOptions = 11104,
  RTCCertificate = 11128,
  RTCDTMFSender = 11143,
  RTCDTMFToneChangeEvent = 11157,
  RTCDataChannel = 11180,
  RTCDataChannelEvent = 11195,
  RTCDtlsTransport = 11215,
  RTCEncodedAudioFrame = 11232,
  RTCEncodedVideoFrame = 11253,
  RTCIceCandidate = 11274,
  RTCIceTransport = 11290,
  RTCIdentityProviderRegistrar = 11306,
  RTCPeerConnection = 11335,
  RTCPeerConnectionIceEvent = 11353,
  RTCPeerConnectionStatic = 11379,
  RTCRtpReceiver = 11403,
  RTCRtpScriptTransform = 11418,
  RTCRtpScriptTransformer = 11440,
  RTCRtpSender = 11464,
  RTCRtpTransceiver = 11477,
  RTCSctpTransport = 11495,
  RTCSessionDescription = 11512,
  RTCStatsReport = 11534,
  RTCTrackEvent = 11549,
  RTCTransformEvent = 11563,
  RadioNodeList = 11581,
  Range = 11595,
  ReadableByteStreamController = 11601,
  ReadableStream = 11630,
  ReadableStream_AsyncIterator = 11645,
  ReadableStreamBYOBReader = 11674,
  ReadableStreamBYOBRequest = 11699,
  ReadableStreamDefaultController = 11725,
  ReadableStreamDefaultReader = 11757,
  Report = 11785,
  ReportBody = 11792,
  ReportingObserver = 11803,
  Request = 11821,
  ResizeObserver = 11829,
  ResizeObserverEntry = 11844,
  ResizeObserverSize = 11864,
  Response = 11883,
  SVGAElement = 11892,
  SVGAngle = 11904,
  SVGAnimateElement = 11913,
  SVGAnimateMotionElement = 11931,
  SVGAnimateTransformElement = 11955,
  SVGAnimatedAngle = 11982,
  SVGAnimatedBoolean = 11999,
  SVGAnimatedEnumeration = 12018,
  SVGAnimatedInteger = 12041,
  SVGAnimatedLength = 12060,
  SVGAnimatedLengthList = 12078,
  SVGAnimatedNumber = 12100,
  SVGAnimatedNumberList = 12118,
  SVGAnimatedPreserveAspectRatio = 12140,
  SVGAnimatedRect = 12171,
  SVGAnimatedString = 12187,
  SVGAnimatedTransformList = 12205,
  SVGAnimationElement = 12230,
  SVGCircleElement = 12250,
  SVGClipPathElement = 12267,
  SVGComponentTransferFunctionElement = 12286,
  SVGDefsElement = 12322,
  SVGDescElement = 12337,
  SVGDiscardElement = 12352,
  SVGElement = 12370,
  SVGEllipseElement = 12381,
  SVGFEBlendElement = 12399,
  SVGFEColorMatrixElement = 12417,
  SVGFEComponentTransferElement = 12441,
  SVGFECompositeElement = 12471,
  SVGFEConvolveMatrixElement = 12493,
  SVGFEDiffuseLightingElement = 12520,
  SVGFEDisplacementMapElement = 12548,
  SVGFEDistantLightElement = 12576,
  SVGFEDropShadowElement = 12601,
  SVGFEFloodElement = 12624,
  SVGFEFuncAElement = 12642,
  SVGFEFuncBElement = 12660,
  SVGFEFuncGElement = 12678,
  SVGFEFuncRElement = 12696,
  SVGFEGaussianBlurElement = 12714,
  SVGFEImageElement = 12739,
  SVGFEMergeElement = 12757,
  SVGFEMergeNodeElement = 12775,
  SVGFEMorphologyElement = 12797,
  SVGFEOffsetElement = 12820,
  SVGFEPointLightElement = 12839,
  SVGFESpecularLightingElement = 12862,
  SVGFESpotLightElement = 12891,
  SVGFETileElement = 12913,
  SVGFETurbulenceElement = 12930,
  SVGFilterElement = 12953,
  SVGForeignObjectElement = 12970,
  SVGGElement = 12994,
  SVGGeometryElement = 13006,
  SVGGradientElement = 13025,
  SVGGraphicsElement = 13044,
  SVGImageElement = 13063,
  SVGLength = 13079,
  SVGLengthList = 13089,
  SVGLineElement = 13103,
  SVGLinearGradientElement = 13118,
  SVGMPathElement = 13143,
  SVGMarkerElement = 13159,
  SVGMaskElement = 13176,
  SVGMatrix = 13191,
  SVGMetadataElement = 13201,
  SVGNumber = 13220,
  SVGNumberList = 13230,
  SVGPathElement = 13244,
  SVGPathSegment = 13259,
  SVGPatternElement = 13274,
  SVGPoint = 13292,
  SVGPointList = 13301,
  SVGPolygonElement = 13314,
  SVGPolylineElement = 13332,
  SVGPreserveAspectRatio = 13351,
  SVGRadialGradientElement = 13374,
  SVGRect = 13399,
  SVGRectElement = 13407,
  SVGSVGElement = 13422,
  SVGScriptElement = 13436,
  SVGSetElement = 13453,
  SVGStopElement = 13467,
  SVGStringList = 13482,
  SVGStyleElement = 13496,
  SVGSwitchElement = 13512,
  SVGSymbolElement = 13529,
  SVGTSpanElement = 13546,
  SVGTextContentElement = 13562,
  SVGTextElement = 13584,
  SVGTextPathElement = 13599,
  SVGTextPositioningElement = 13618,
  SVGTitleElement = 13644,
  SVGTransform = 13660,
  SVGTransformList = 13673,
  SVGUnitTypes = 13690,
  SVGUseElement = 13703,
  SVGViewElement = 13717,
  Sanitizer = 13732,
  Scheduler = 13742,
  Screen = 13752,
  ScreenLuminance = 13759,
  ScreenOrientation = 13775,
  ScriptProcessorNode = 13793,
  ScrollAreaEvent = 13813,
  ScrollViewChangeEvent = 13829,
  SecurityPolicyViolationEvent = 13851,
  Selection = 13880,
  ServiceWorker = 13890,
  ServiceWorkerContainer = 13904,
  ServiceWorkerGlobalScope = 13927,
  ServiceWorkerRegistration = 13952,
  SessionStoreFormData = 13978,
  SessionStoreScrollData = 13999,
  SessionStoreUtils = 14022,
  ShadowRealmGlobalScope = 14040,
  ShadowRoot = 14063,
  SharedWorker = 14074,
  SharedWorkerGlobalScope = 14087,
  SimpleGestureEvent = 14111,
  SourceBuffer = 14130,
  SourceBufferList = 14143,
  SpeechGrammar = 14160,
  SpeechGrammarList = 14174,
  SpeechRecognition = 14192,
  SpeechRecognitionAlternative = 14210,
  SpeechRecognitionError = 14239,
  SpeechRecognitionEvent = 14262,
  SpeechRecognitionResult = 14285,
  SpeechRecognitionResultList = 14309,
  SpeechSynthesis = 14337,
  SpeechSynthesisErrorEvent = 14353,
  SpeechSynthesisEvent = 14379,
  SpeechSynthesisUtterance = 14400,
  SpeechSynthesisVoice = 14425,
  StaticRange = 14446,
  StereoPannerNode = 14458,
  Storage = 14475,
  StorageEvent = 14483,
  StorageManager = 14496,
  StreamFilter = 14511,
  StreamFilterDataEvent = 14524,
  StructuredCloneHolder = 14546,
  StructuredCloneTester = 14568,
  StyleSheet = 14590,
  StyleSheetApplicableStateChangeEvent = 14601,
  StyleSheetList = 14638,
  StyleSheetRemovedEvent = 14653,
  SubmitEvent = 14676,
  SubtleCrypto = 14688,
  SyncMessageSender = 14701,
  SyncReadFile = 14719,
  TCPServerSocket = 14732,
  TCPServerSocketEvent = 14748,
  TCPSocket = 14769,
  TCPSocketErrorEvent = 14779,
  TCPSocketEvent = 14799,
  TaskController = 14814,
  TaskPriorityChangeEvent = 14829,
  TaskSignal = 14853,
  TelemetryStopwatch = 14864,
  TestAttributesOnTypes = 14883,
  TestCEReactionsInterface = 14905,
  TestCImplementedInterface = 14930,
  TestCImplementedInterface2 = 14956,
  TestCallbackDictUnionOverload = 14983,
  TestChildInterface = 15013,
  TestConstructorForFuncInterface = 15032,
  TestConstructorForPrefInterface = 15064,
  TestConstructorForSCInterface = 15096,
  TestCppKeywordNamedMethodsInterface = 15126,
  TestDeprecatedInterface = 15162,
  TestExampleInterface = 15186,
  TestExampleProxyInterface = 15207,
  TestExampleThrowingConstructorInterface = 15233,
  TestExampleWorkerInterface = 15273,
  TestFuncConstructorForDifferentFuncInterface = 15300,
  TestFuncConstructorForInterface = 15345,
  TestHTMLConstructorInterface = 15377,
  TestIndexedAndNamedGetterAndSetterInterface = 15406,
  TestIndexedAndNamedGetterInterface = 15450,
  TestIndexedAndNamedSetterInterface = 15485,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 15520,
  TestIndexedGetterInterface = 15570,
  TestIndexedSetterInterface = 15597,
  TestInterface = 15624,
  TestInterfaceWithPromiseConstructorArg = 15638,
  TestJSImplInterface = 15677,
  TestJSImplInterface2 = 15697,
  TestJSImplInterface3 = 15718,
  TestJSImplInterface4 = 15739,
  TestJSImplInterface5 = 15760,
  TestJSImplInterface6 = 15781,
  TestJSImplNoInterfaceObject = 15802,
  TestLegacyFactoryFunctionInterface = 15830,
  TestLegacyFactoryFunctionInterface2 = 15865,
  TestNamedDeleterInterface = 15901,
  TestNamedDeleterWithRetvalInterface = 15927,
  TestNamedGetterInterface = 15963,
  TestNamedSetterInterface = 15988,
  TestNamespace = 16013,
  TestNonWrapperCacheInterface = 16027,
  TestParentInterface = 16056,
  TestPrefChromeOnlySCFuncConstructorForInterface = 16076,
  TestPrefConstructorForDifferentPrefInterface = 16124,
  TestPrefConstructorForInterface = 16169,
  TestProtoObjectHackedNamespace = 16201,
  TestRenamedInterface = 16232,
  TestRenamedNamespace = 16253,
  TestSCConstructorForInterface = 16274,
  TestSecureContextInterface = 16304,
  TestThrowingConstructorInterface = 16331,
  TestUtils = 16364,
  TestWorkerExposedInterface = 16374,
  TestingDeprecatedInterface = 16401,
  Text = 16428,
  TextClause = 16433,
  TextDecoder = 16444,
  TextDecoderStream = 16456,
  TextEncoder = 16474,
  TextEncoderStream = 16486,
  TextEvent = 16504,
  TextMetrics = 16514,
  TextTrack = 16526,
  TextTrackCue = 16536,
  TextTrackCueList = 16549,
  TextTrackList = 16566,
  TimeEvent = 16580,
  TimeRanges = 16590,
  ToggleEvent = 16601,
  Touch = 16613,
  TouchEvent = 16619,
  TouchList = 16630,
  TrackEvent = 16640,
  TransformStream = 16651,
  TransformStreamDefaultController = 16667,
  TransitionEvent = 16700,
  TreeColumn = 16716,
  TreeColumns = 16727,
  TreeContentView = 16739,
  TreeWalker = 16755,
  TrustedHTML = 16766,
  TrustedScript = 16778,
  TrustedScriptURL = 16792,
  TrustedTypePolicy = 16809,
  TrustedTypePolicyFactory = 16827,
  UDPMessageEvent = 16852,
  UDPSocket = 16868,
  UIEvent = 16878,
  URL = 16886,
  URLSearchParams = 16890,
  URLSearchParams_Iterator = 16906,
  UniFFIPointer = 16931,
  UniFFIScaffolding = 16945,
  UserActivation = 16963,
  UserInteraction = 16978,
  UserProximityEvent = 16994,
  VRDisplay = 17013,
  VRDisplayCapabilities = 17023,
  VRDisplayEvent = 17045,
  VREyeParameters = 17060,
  VRFieldOfView = 17076,
  VRFrameData = 17090,
  VRMockController = 17102,
  VRMockDisplay = 17119,
  VRPose = 17133,
  VRServiceTest = 17140,
  VRStageParameters = 17154,
  VTTCue = 17172,
  VTTRegion = 17179,
  ValidityState = 17189,
  VideoColorSpace = 17203,
  VideoDecoder = 17219,
  VideoEncoder = 17232,
  VideoFrame = 17245,
  VideoPlaybackQuality = 17256,
  VideoTrack = 17277,
  VideoTrackList = 17288,
  ViewTransition = 17303,
  VisualViewport = 17318,
  WEBGL_color_buffer_float = 17333,
  WEBGL_compressed_texture_astc = 17358,
  WEBGL_compressed_texture_etc = 17388,
  WEBGL_compressed_texture_etc1 = 17417,
  WEBGL_compressed_texture_pvrtc = 17447,
  WEBGL_compressed_texture_s3tc = 17478,
  WEBGL_compressed_texture_s3tc_srgb = 17508,
  WEBGL_debug_renderer_info = 17543,
  WEBGL_debug_shaders = 17569,
  WEBGL_depth_texture = 17589,
  WEBGL_draw_buffers = 17609,
  WEBGL_explicit_present = 17628,
  WEBGL_lose_context = 17651,
  WEBGL_provoking_vertex = 17670,
  WGSLLanguageFeatures = 17693,
  WakeLock = 17714,
  WakeLockSentinel = 17723,
  WaveShaperNode = 17740,
  WebExtensionContentScript = 17755,
  WebExtensionPolicy = 17781,
  WebGL2RenderingContext = 17800,
  WebGLActiveInfo = 17823,
  WebGLBuffer = 17839,
  WebGLContextEvent = 17851,
  WebGLFramebuffer = 17869,
  WebGLProgram = 17886,
  WebGLQuery = 17899,
  WebGLRenderbuffer = 17910,
  WebGLRenderingContext = 17928,
  WebGLSampler = 17950,
  WebGLShader = 17963,
  WebGLShaderPrecisionFormat = 17975,
  WebGLSync = 18002,
  WebGLTexture = 18012,
  WebGLTransformFeedback = 18025,
  WebGLUniformLocation = 18048,
  WebGLVertexArrayObject = 18069,
  WebKitCSSMatrix = 18092,
  WebSocket = 18108,
  WebTransport = 18118,
  WebTransportBidirectionalStream = 18131,
  WebTransportDatagramDuplexStream = 18163,
  WebTransportError = 18196,
  WebTransportReceiveStream = 18214,
  WebTransportSendStream = 18240,
  WebrtcGlobalInformation = 18263,
  WheelEvent = 18287,
  Window = 18298,
  WindowClient = 18305,
  WindowContext = 18318,
  WindowGlobalChild = 18332,
  WindowGlobalParent = 18350,
  WindowRoot = 18369,
  Worker = 18380,
  WorkerDebuggerGlobalScope = 18387,
  WorkerGlobalScope = 18413,
  WorkerLocation = 18431,
  WorkerNavigator = 18446,
  WorkerTestUtils = 18462,
  Worklet = 18478,
  WorkletGlobalScope = 18486,
  WritableStream = 18505,
  WritableStreamDefaultController = 18520,
  WritableStreamDefaultWriter = 18552,
  XMLDocument = 18580,
  XMLHttpRequest = 18592,
  XMLHttpRequestEventTarget = 18607,
  XMLHttpRequestUpload = 18633,
  XMLSerializer = 18654,
  XPathEvaluator = 18668,
  XPathExpression = 18683,
  XPathResult = 18699,
  XRBoundedReferenceSpace = 18711,
  XRFrame = 18735,
  XRInputSource = 18743,
  XRInputSourceArray = 18757,
  XRInputSourceEvent = 18776,
  XRInputSourcesChangeEvent = 18795,
  XRPose = 18821,
  XRReferenceSpace = 18828,
  XRReferenceSpaceEvent = 18845,
  XRRenderState = 18867,
  XRRigidTransform = 18881,
  XRSession = 18898,
  XRSessionEvent = 18908,
  XRSpace = 18923,
  XRSystem = 18931,
  XRView = 18940,
  XRViewerPose = 18947,
  XRViewport = 18960,
  XRWebGLLayer = 18971,
  XSLTProcessor = 18984,
  XULCommandEvent = 18998,
  XULElement = 19014,
  XULFrameElement = 19025,
  XULMenuElement = 19041,
  XULPopupElement = 19056,
  XULResizerElement = 19072,
  XULTextElement = 19090,
  XULTreeElement = 19105,
  console = 19120,
  webkitSpeechGrammar = 19128,
  webkitSpeechGrammarList = 19148,
  webkitSpeechRecognition = 19172,
  webkitURL = 19196,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
