// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser v16.2.0. DO NOT EDIT. DO NOT COMMIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
pub mod crash {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.app_build
    ///
    /// The build id of the application. This may differ from `client_info` because a
    /// main process crash may be reported later by a different (e.g. updated) client.
    pub static app_build: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "app_build".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.app_channel
    ///
    /// The release channel of the application. This may differ from `client_info`
    /// because a main process crash may be reported later by a different (e.g.
    /// updated) client.
    pub static app_channel: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "app_channel".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.app_display_version
    ///
    /// The version of the application. This may differ from `client_info` because a
    /// main process crash may be reported later by a different (e.g. updated) client.
    pub static app_display_version: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "app_display_version".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });

    #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[serde(crate = "::glean::traits::__serde")]
    #[serde(deny_unknown_fields)]
    pub struct AsyncShutdownTimeoutObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub phase: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub conditions: Option<String>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new", deserialize_with = "::glean::traits::__serde_helper::vec_null")]
          pub broken_add_blockers: AsyncShutdownTimeoutObjectBrokenAddBlockers,
    }

            pub type AsyncShutdownTimeoutObjectBrokenAddBlockers = Vec<AsyncShutdownTimeoutObjectBrokenAddBlockersItem>;

    
pub type AsyncShutdownTimeoutObjectBrokenAddBlockersItem = String;









    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.async_shutdown_timeout
    ///
    /// Present when a shutdown blocker failed to respond within a reasonable amount of
    /// time.
    pub static async_shutdown_timeout: ::glean::private::__export::Lazy<ObjectMetric<AsyncShutdownTimeoutObject>> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "async_shutdown_timeout".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        ObjectMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.background_task_name
    ///
    /// The name of the background task if launched as one.
    pub static background_task_name: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "background_task_name".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.event_loop_nesting_level
    ///
    /// Indicates the nesting level of the event loop.
    pub static event_loop_nesting_level: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "event_loop_nesting_level".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.font_name
    ///
    /// The font family name that is being loaded when the crash occurred.
    pub static font_name: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "font_name".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.gpu_process_launch
    ///
    /// The number of times that the GPU process was launched.
    pub static gpu_process_launch: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "gpu_process_launch".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.ipc_channel_error
    ///
    /// The error reason for an ipc-based content crash.
    pub static ipc_channel_error: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "ipc_channel_error".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.is_garbage_collecting
    ///
    /// Indicates that the crash occurred while the garbage collector was running.
    pub static is_garbage_collecting: ::glean::private::__export::Lazy<BooleanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "is_garbage_collecting".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        BooleanMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.main_thread_runnable_name
    ///
    /// Name of the currently executing `nsIRunnable` on the main thread. Nightly-only.
    pub static main_thread_runnable_name: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "main_thread_runnable_name".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.minidump_sha256_hash
    ///
    /// The SHA256 hash of the associated minidump file, if any.
    pub static minidump_sha256_hash: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "minidump_sha256_hash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.moz_crash_reason
    ///
    /// Contains the string passed to `MOZ_CRASH()`.
    pub static moz_crash_reason: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "moz_crash_reason".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.process_type
    ///
    /// The type of process that experienced a crash. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
    /// types).
    pub static process_type: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "process_type".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.profiler_child_shutdown_phase
    ///
    /// The shutdown phase of the profiler.
    pub static profiler_child_shutdown_phase: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "profiler_child_shutdown_phase".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });

    pub type QuotaManagerShutdownTimeoutObject = Vec<QuotaManagerShutdownTimeoutObjectItem>;

    
pub type QuotaManagerShutdownTimeoutObjectItem = String;






    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.quota_manager_shutdown_timeout
    ///
    /// Contains a list of shutdown steps and status of the quota manager clients.
    pub static quota_manager_shutdown_timeout: ::glean::private::__export::Lazy<ObjectMetric<QuotaManagerShutdownTimeoutObject>> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "quota_manager_shutdown_timeout".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        ObjectMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.remote_type
    ///
    /// The type of the content process. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#remote-
    /// process-types).
    pub static remote_type: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "remote_type".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.shutdown_progress
    ///
    /// The shutdown phase in which the crash occurred.
    pub static shutdown_progress: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "shutdown_progress".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });

    #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[serde(crate = "::glean::traits::__serde")]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub error: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_type: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_thread: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new", deserialize_with = "::glean::traits::__serde_helper::vec_null")]
          pub modules: StackTracesObjectModules,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new", deserialize_with = "::glean::traits::__serde_helper::vec_null")]
          pub threads: StackTracesObjectThreads,
    }

            pub type StackTracesObjectModules = Vec<StackTracesObjectModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[serde(crate = "::glean::traits::__serde")]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub code_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_file: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub filename: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
    }







            pub type StackTracesObjectThreads = Vec<StackTracesObjectThreadsItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[serde(crate = "::glean::traits::__serde")]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectThreadsItem {
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new", deserialize_with = "::glean::traits::__serde_helper::vec_null")]
          pub frames: StackTracesObjectThreadsItemFrames,
    }

            pub type StackTracesObjectThreadsItemFrames = Vec<StackTracesObjectThreadsItemFramesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[serde(crate = "::glean::traits::__serde")]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectThreadsItemFramesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub module_index: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub ip: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub trust: Option<String>,
    }
















    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.stack_traces
    ///
    /// Stack trace and module information of the crashing process.
    pub static stack_traces: ::glean::private::__export::Lazy<ObjectMetric<StackTracesObject>> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "stack_traces".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        ObjectMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.startup
    ///
    /// If true, the crash occurred during process startup.
    pub static startup: ::glean::private::__export::Lazy<BooleanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "startup".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        BooleanMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.time
    ///
    /// The time at which the crash occurred.
    pub static time: ::glean::private::__export::Lazy<DatetimeMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "time".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        DatetimeMetric::new(meta, TimeUnit::Millisecond)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.utility_actors_name
    ///
    /// List of IPC actor names running on a utility process instance (if the crashing
    /// process was a utility process).
    pub static utility_actors_name: ::glean::private::__export::Lazy<StringListMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash".into(),
                name: "utility_actors_name".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringListMetric::new(meta)
    });
}
pub mod crash_windows {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.windows.error_reporting
    ///
    /// Indicates if the crash was intercepted by the Windows Error Reporting runtime
    /// exception module.
    pub static error_reporting: ::glean::private::__export::Lazy<BooleanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash.windows".into(),
                name: "error_reporting".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        BooleanMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash.windows.file_dialog_error_code
    ///
    /// The HRESULT returned from a Win32 system call leading to termination of the
    /// file-dialog utility process. MozCrashReason is expected to provide context for
    /// the value.
    pub static file_dialog_error_code: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash.windows".into(),
                name: "file_dialog_error_code".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });
}
pub mod crash_submission {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash_submission.channel_status
    ///
    /// Collecting XHR channel status on error code when statusCode == 0.
    pub static channel_status: ::glean::private::__export::Lazy<LabeledMetric<CounterMetric>> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    category: "crash_submission".into(),
                    name: "channel_status".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }
,
            };
        LabeledMetric::new(meta, None)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash_submission.collector_errors
    ///
    /// Amount and error name reported when performing crash submission.
    pub static collector_errors: ::glean::private::__export::Lazy<LabeledMetric<CounterMetric>> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    category: "crash_submission".into(),
                    name: "collector_errors".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }
,
            };
        LabeledMetric::new(meta, None)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash_submission.failure
    ///
    /// Number of failed crash report submissions
    pub static failure: ::glean::private::__export::Lazy<CounterMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash_submission".into(),
                name: "failure".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        CounterMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash_submission.pending
    ///
    /// Number of pending crash report submissions
    pub static pending: ::glean::private::__export::Lazy<CounterMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash_submission".into(),
                name: "pending".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        CounterMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from crash_submission.success
    ///
    /// Number of successfull crash report submissions
    pub static success: ::glean::private::__export::Lazy<CounterMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "crash_submission".into(),
                name: "success".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        CounterMetric::new(meta)
    });
}
pub mod dll_blocklist {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from dll_blocklist.init_failed
    ///
    /// Indicates whether initialization of the DLL blocklist failed.
    pub static init_failed: ::glean::private::__export::Lazy<BooleanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "dll_blocklist".into(),
                name: "init_failed".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        BooleanMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from dll_blocklist.list
    ///
    /// A list of blocked DLLs.
    pub static list: ::glean::private::__export::Lazy<StringListMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "dll_blocklist".into(),
                name: "list".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringListMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from dll_blocklist.user32_loaded_before
    ///
    /// Indicates whether `user32.dll` was loaded before the DLL blocklist was
    /// initialized.
    pub static user32_loaded_before: ::glean::private::__export::Lazy<BooleanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "dll_blocklist".into(),
                name: "user32_loaded_before".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        BooleanMetric::new(meta)
    });
}
pub mod environment {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from environment.experimental_features
    ///
    /// Specifies the enabled experimental features from
    /// about:preferences#experimental.
    pub static experimental_features: ::glean::private::__export::Lazy<StringListMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "environment".into(),
                name: "experimental_features".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringListMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from environment.headless_mode
    ///
    /// Whether the app was invoked in headless mode via `--headless` or
    /// `--backgroundtask`.
    pub static headless_mode: ::glean::private::__export::Lazy<BooleanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "environment".into(),
                name: "headless_mode".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        BooleanMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from environment.uptime
    ///
    /// The start time of the application.
    pub static uptime: ::glean::private::__export::Lazy<TimespanMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "environment".into(),
                name: "uptime".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        TimespanMetric::new(meta, TimeUnit::Millisecond)
    });
}
pub mod memory {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.available_commit
    ///
    /// Available commit size.
    pub static available_commit: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "available_commit".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.available_physical
    ///
    /// Available physical memory.
    pub static available_physical: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "available_physical".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.available_swap
    ///
    /// Available swap memory.
    pub static available_swap: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "available_swap".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.available_virtual
    ///
    /// Available virtual memory.
    pub static available_virtual: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "available_virtual".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.low_physical
    ///
    /// The number of times the available memory tracker has detected that free
    /// physical memory is running low.
    pub static low_physical: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "low_physical".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.oom_allocation_size
    ///
    /// The size of the allocation that caused on OOM crash.
    pub static oom_allocation_size: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "oom_allocation_size".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.purgeable_physical
    ///
    /// The amount of memory that can be deallocated by the OS in case of memory
    /// pressure.
    pub static purgeable_physical: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "purgeable_physical".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.system_use_percentage
    ///
    /// The percentage of memory in use.
    pub static system_use_percentage: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "system_use_percentage".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.texture
    ///
    /// The amount of memory used in textures.
    pub static texture: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "texture".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.total_page_file
    ///
    /// The total page file size.
    pub static total_page_file: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "total_page_file".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.total_physical
    ///
    /// The total physical memory.
    pub static total_physical: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "total_physical".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from memory.total_virtual
    ///
    /// The total virtual memory.
    pub static total_virtual: ::glean::private::__export::Lazy<QuantityMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "memory".into(),
                name: "total_virtual".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        QuantityMetric::new(meta)
    });
}
pub mod windows {
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::{private::*, traits::ExtraKeys, traits::NoExtraKeys, CommonMetricData, HistogramType, LabeledMetricData, Lifetime, TimeUnit, MemoryUnit};


    #[allow(non_upper_case_globals, dead_code)]
    /// generated from windows.package_family_name
    ///
    /// The Package Family Name of Firefox, if installed through an MSIX package.
    pub static package_family_name: ::glean::private::__export::Lazy<StringMetric> = ::glean::private::__export::Lazy::new(|| {
        let meta =
            CommonMetricData {
                category: "windows".into(),
                name: "package_family_name".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            }
;
        StringMetric::new(meta)
    });
}
#[allow(non_upper_case_globals, dead_code)]
/// A ping to report crash information. This information is sent as soon as
/// possible after a crash occurs (whether the crash is a background/content
/// process or the main process). It is expected to be used for crash report
/// analysis and to reduce blind spots in crash reporting.
#[rustfmt::skip]
pub static crash: ::glean::private::__export::Lazy<::glean::private::PingType> =
    ::glean::private::__export::Lazy::new(|| ::glean::private::PingType::new("crash", true, false, true, true, true, vec![], vec!["crash".into(), "event_found".into()], true));
